Name:		hp-e1000e
Version:	3.2.7.2
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://support.intel.com/support/go/linux/e1000e.htm
Packager:	Hewlett-Packard Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:	%{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	HP NC Series Intel e1000e Driver for Linux

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hp.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hp.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HP NC Series Intel e1000e Driver for Linux
Group: System/Kernel

%description KMP
Intel(R) Gigabit Ethernet Kernel Module for HP ProLiant systems
SRPMS available at http://downloads.linux.hp.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hp.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HP NC Series Intel e1000e Driver for Linux

%prep
%setup
mkdir source
set -- src/*
mv src/* source/
mkdir obj
echo "override e1000e * weak-updates/%{name}" > %{name}.conf

%build
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C %{kernel_source $flavor} M=$PWD/obj/$flavor

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < e1000e.7 > e1000e.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 e1000e.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/e1000e.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%postun doc
if [ -f %{_mandir}/man7/e1000e.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/e1000e.7.gz
%doc COPYING README

%changelog
* Mon Oct 19 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
 - Added SLES12SP1 support
 - Added RHEL 7.2 support
 - This driver corrects a issue where the unit becomes unresponsive during a hardware reset.
 - This driver corrects a transmission hang seen during diagnostics, which makes the network adapter unusable.

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.2.2.1-19
 - Added SLES11SP4 support
 - Added RHEL 6.7 support

* Tue Mar 17 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.2.2.1-10
 - Added RHEL7.1 support

* Wed Oct 28 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.2.2.1
 - Added SLES 12 support
 - Added RHEL 6.6 support
 - Fixed the issue of interface not receiving traffic when there is no cable attached.

* Wed May 21 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.0.4.1-1
 - Fixed compatability issues with Linux 2.4.x kernels

* Wed Nov 27 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.5.7-4
 - Fixed panic with Rx traffic while interface is going down
 - Add support for I218 "Ultra-Low Power" (ULP) mode enabled in S3/4 and in S0 when Runtime Power Management (RPM) is enabled
 - Fixed multiple Runtime Power Management (RPM) issues
 - Fixed a Tx hang inssue at 100Half on I218
 - Fixed numeric overflow in phc settime method
 - Fixed issue of AMT connection drops after driver unload if large MTU configured
 - Fixed low throughput issues and high CRC error count issues using 4K jumbo MTU
 - Fixed vlan support issues for kernels 3.10 and above

* Mon Jul 15 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.4.4-5
 - Initial package
 - Fixed panics when the driver is loaded on 8257x and 80003es2lan non-copper devices (Severity: Critical)
 - Fixed slow performance experienced by ICH9/ICH10 interfaces with 9K Jumbo
 - Fixed EEE in Sx power consumption higher than LPLU
